      SUBROUTINE AFG5R(A,M,N,NLEAD,IERR)
C********************************************************************C
C  LU-PAOEHE MATP A METOOM AYCCA C BOPOM                  C
C  BEYEO  EMEHTA O CTOY                                     C
C                                                                    C
C  M-CO CTPOK MATP(T:INTEGER)                                C
C  N-PAMEP MATP(T:INTEGER)                                     C
C  A-MATPA M*N,HA BXOE COEPT CXOHY MATPY,                 C
C  HA BXOE HA COOTBETCTBYX MECTAX HAXOTC EMEHT            C
C  MATP U  OAOHAHE EMEHT MATP INVERSE(L)(T:REAL) C
C  NLEAD-BEKTOP H N,HA BXOE COEPT BEKTOP,OPOA        C
C  MATPY EPECTAHOBOK(T:INTEGER)                                 C
C  IERR-EPEMEHHA,YKABAA PHY BXOA(T:INTEGER)           C
C                                                                    C
C********************************************************************C
         INTEGER IERR,M,N,NLEAD
         REAL A
         DIMENSION A(M,1),NLEAD(1)
C
C  YCTAHOBEHE KOHTPO HA BOMOHOCT EPEOHEH
         EXTERNAL UTAFSI
         INTEGER I,J,JJ,K,KP1,L,NM1
         REAL T,X
       X = 0.0
   10  CONTINUE
C
C  POBEPKA PABHOCT AAH APAMETPOB M  N
       IF (N .GE. 1 .AND. M .GE. 1) GO TO 20
          IERR = 65
          CALL UTAFSI(1HA,1HF,1HG,1H5,1HR,IERR)
          GO TO 200
   20  CONTINUE
       IERR = 0
       NM1 = N - 1
       IF (NM1 .LT. 1) GO TO 190
          DO 180 K = 1, NM1
             KP1 = K + 1
C
C  HAXOEHE HEKCA BEYEO EMEHTA L
             L = K
             T = ABS(A(K,K))
             DO 40 J = KP1, N
                IF (ABS(A(J,K)) .LE. T) GO TO 30
                   L = J
                   T = ABS(A(J,K))
   30           CONTINUE
   40        CONTINUE
             NLEAD(K) = L
             IF (A(L,K) .EQ. 0.0) GO TO 160
C
C  EPECTAHOBKA,EC TPEYETC
                IF (L .EQ. K) GO TO 50
                   T = A(L,K)
                   A(L,K) = A(K,K)
                   A(K,K) = T
   50           CONTINUE
C
C  BCEHE MHOTEE
                T = -1./A(K,K)
                J = N - K
                I = MOD(J,5) + K
                IF (I .EQ. K) GO TO 70
                   DO 60 J = KP1, I
                      A(J,K) = T*A(J,K)
   60              CONTINUE
   70           CONTINUE
                I = I + 1
                IF (I .GT. N) GO TO 90
                   DO 80 J = I, N, 5
                      A(J,K) = T*A(J,K)
                      A(J+1,K) = T*A(J+1,K)
                      A(J+2,K) = T*A(J+2,K)
                      A(J+3,K) = T*A(J+3,K)
                      A(J+4,K) = T*A(J+4,K)
   80              CONTINUE
   90           CONTINUE
C
C  AYCCOBO CKEHE
                DO 150 J = KP1, N
                   T = A(L,J)
                   IF (L .EQ. K) GO TO 100
                      A(L,J) = A(K,J)
                      A(K,J) = T
  100              CONTINUE
                   JJ = N - K
                   I = MOD(JJ,4) + K
                   IF (I .EQ. K) GO TO 120
                      DO 110 JJ = KP1, I
                         A(JJ,J) = A(JJ,J) + T*A(JJ,K)
  110                 CONTINUE
  120              CONTINUE
                   I = I + 1
                   IF (I .GT. N) GO TO 140
                      DO 130 JJ = I, N, 4
                         A(JJ,J) = A(JJ,J) + T*A(JJ,K)
                         A(JJ+1,J) = A(JJ+1,J) + T*A(JJ+1,K)
                         A(JJ+2,J) = A(JJ+2,J) + T*A(JJ+2,K)
                         A(JJ+3,J) = A(JJ+3,J) + T*A(JJ+3,K)
  130                 CONTINUE
  140              CONTINUE
  150           CONTINUE
                GO TO 170
  160     CONTINUE
          IERR = -K
  170     CONTINUE
  180  CONTINUE
  190  CONTINUE
       NLEAD(N) = N
       IF (A(N,N) .EQ. 0.0) IERR = -N
       IF (IERR .EQ. 0) GO TO 200
          CALL UTAFSI(1HA,1HF,1HG,1H5,1HR,IERR)
  200  CONTINUE
       RETURN
      END
